from __future__ import annotations
import srf.benchmarking.watchers
import typing
import srf.benchmarking.tracers
import srf.core.executor
import srf.core.node
import srf.core.segment

__all__ = [
    "LatencyWatcher",
    "ThroughputWatcher"
]


class LatencyWatcher():
    @typing.overload
    def __init__(self, arg0: srf.core.executor.Executor) -> None: ...
    @typing.overload
    def __init__(self, arg0: srf.core.executor.Executor, arg1: typing.Callable[[srf.benchmarking.tracers.LatencyTracer], None]) -> None: ...
    def aggregate_tracers(self) -> dict: ...
    def is_running(self) -> bool: ...
    def make_segment(self, arg0: str, arg1: typing.Callable[[srf.core.segment.Builder, LatencyWatcher], None]) -> None: ...
    def make_traced_node(self, arg0: srf.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], object]) -> srf.core.node.SegmentObject: ...
    def make_tracer_sink(self, arg0: srf.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], None]) -> srf.core.node.SegmentObject: ...
    def make_tracer_source(self, arg0: srf.core.segment.Builder, arg1: str, arg2: bool) -> srf.core.node.SegmentObject: ...
    def reset(self) -> None: ...
    def run(self) -> None: ...
    def shutdown(self) -> None: ...
    def start_trace(self, arg0: bool) -> None: ...
    def stop_trace(self) -> None: ...
    def trace_until_notified(self) -> None: ...
    def tracer_count(self, arg0: int) -> None: ...
    def tracing(self) -> bool: ...
    pass
class ThroughputWatcher():
    @typing.overload
    def __init__(self, arg0: srf.core.executor.Executor) -> None: ...
    @typing.overload
    def __init__(self, arg0: srf.core.executor.Executor, arg1: typing.Callable[[srf.benchmarking.tracers.ThroughputTracer], None]) -> None: ...
    def aggregate_tracers(self) -> dict: ...
    def is_running(self) -> bool: ...
    def make_segment(self, arg0: str, arg1: typing.Callable[[srf.core.segment.Builder, ThroughputWatcher], None]) -> None: ...
    def make_traced_node(self, arg0: srf.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], object]) -> srf.core.node.SegmentObject: ...
    def make_tracer_sink(self, arg0: srf.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], None]) -> srf.core.node.SegmentObject: ...
    def make_tracer_source(self, arg0: srf.core.segment.Builder, arg1: str, arg2: bool) -> srf.core.node.SegmentObject: ...
    def reset(self) -> None: ...
    def run(self) -> None: ...
    def shutdown(self) -> None: ...
    def start_trace(self, arg0: bool) -> None: ...
    def stop_trace(self) -> None: ...
    def trace_until_notified(self) -> None: ...
    def tracer_count(self, arg0: int) -> None: ...
    def tracing(self) -> bool: ...
    pass
