"""
        Python bindings for SRF Plugins
        -------------------------------
        .. currentmodule:: plugins
        .. autosummary::
           :toctree: _generate
    """
from __future__ import annotations
import srf.core.plugins
import typing
from srf.core.segment import SegmentModule
import srf.core.common

__all__ = [
    "PluginModule",
    "SegmentModule"
]


class PluginModule():
    def create_or_acquire(self) -> PluginModule: ...
    def list_modules(self) -> typing.List[str]: ...
    def load(self, throw_on_error: bool = True) -> bool: ...
    def reload(self) -> None: ...
    def reset_library_directory(self) -> None: ...
    def set_library_directory(self, path: str) -> None: ...
    def unload(self, throw_on_error: bool = True) -> bool: ...
    pass
__version__ = '22.11.0'
