"""
        Python bindings for SRF subscribers
        -------------------------------
        .. currentmodule:: subscriber
        .. autosummary::
           :toctree: _generate
    """
from __future__ import annotations
import srf.core.subscriber
import typing
import srf.core.common

__all__ = [
    "Observable",
    "Observer",
    "Subscriber",
    "Subscription"
]


class Observable():
    def pipe(self, *args) -> Observable: ...
    @typing.overload
    def subscribe(self, arg0: Observer) -> Subscription: ...
    @typing.overload
    def subscribe(self, arg0: Subscriber) -> Subscription: ...
    pass
class Observer():
    @staticmethod
    def make_observer(arg0: typing.Callable[[object], None], arg1: typing.Callable[[object], None], arg2: typing.Callable[[], None]) -> Observer: ...
    def on_completed(self) -> None: ...
    def on_error(self, arg0: object) -> None: ...
    def on_next(self, arg0: object) -> None: 
        """
        Passes the argument to the next node in the pipeline
        """
    pass
class Subscriber():
    def is_subscribed(self) -> bool: ...
    def on_completed(self) -> None: ...
    def on_error(self, arg0: object) -> None: ...
    def on_next(self, arg0: object) -> None: ...
    pass
class Subscription():
    pass
__version__ = '22.11.0'
